For the exhaustive schema-derived catalog, see all examples.
What it is
Understand sent, delivered, read, and failed WhatsApp message updates.Before you begin
- Create a public HTTPS endpoint in your application.
- Configure a YCloud webhook endpoint for the event types you need.
- Store the endpoint signing secret securely.
- Make event processing idempotent.
How it works
YCloud sends an HTTPPOST request when the event occurs. Verify the signature, durably record the event, return a 2xx response, and process slow work asynchronously.
Request
The scenarios below show requests delivered to your webhook URL. Treat the eventid as the delivery identifier and use type to route the payload.
Response
Return a2xx status after accepting the event.
For endpoint setup, signature validation, and retry behavior, see Configure webhooks.
accepted. Message status updates will trigger the whatsapp.message.updated webhook.
Typically, the message status:
- Changes to
failedif we are unable to deliver this message. - Changes to
sentif it’s possible to deliver this message, and later it may change tofailed,delivered, orread. - Changes to
deliveredorreadif this message was delivered to the recipient’s device.
delivered events may happen after failed, and vice versa, especially when the end user is using multiple devices.
Message Sent
In this case, your webhook endpoint received a messagesent event:
- The message
statusissent, which means the message is in transit within WhatsApp’s systems. - Contains information about the conversation, including the time when the conversation expires, and the origin type.
- Contains the estimated
pricingCategoryandtotalPricewe may charge you. - Contains
wamid, which is the original message ID on WhatsApp’s platform, starting withwamid..
Request
Response
Acknowledge the delivery after durably accepting the event.Explanation
-
totalPriceis only an estimated price before the first message is delivered, and it becomes the final price when thestatusisdeliveredorread. The balance taken up by those messages that are sent but haven’t been delivered will not be available until the messages are dropped (Sent messages that are not delivered for 30 days are dropped). -
Generally, a
sentmessage changes todeliveredorreadsoon, except:- The recipient’s WhatsApp account is offline, your sent WhatsApp messages won’t be delivered until the recipient has working or active internet services.
- Any message sent to a contact who has blocked you will always show the message
sent, and will never change todelivered. - The recipient has turned off read receipts, and you won’t receive the message
readreceipts. - The message changes to
failedlater with error code131026, which means “Message Undeliverable.”, or “Receiver is incapable of receiving this message”. This is most likely that the recipient is not registered, or is using an old WhatsApp version. - The message was not delivered to create a high quality user experience. See Per-User Marketing Template Message Limits.
Message Delivered
In this case, your webhook endpoint received a messagedelivered event:
- The message
statusisdelivered, which means the message was delivered to the recipient’s device.
Request
Response
Acknowledge the delivery after durably accepting the event.Explanation
- This event indicates that the message sent by your business was delivered to the user’s device.
- For a status to be
read, it must have beendelivered. In some scenarios, such as when a user is in the chat screen and a message arrives, the message isdeliveredandreadalmost simultaneously. In this or other similar scenarios, thedeliverednotification will not be sent back, as it is implied that a message has been delivered if it has been read. The reason for this behavior is internal optimization. - It’s possible for us to generate more than 1
deliveredwebhook event for the same message, especially if the end user is using multiple devices. - pricingModel: “PMP”— indicates per-message pricing applies. See also whatsapp-message-pricing-updates
- pricingType
- regular — indicates the message is billable.
- free_customer_service — indicates the message is free because it was either a utility template message or non-template message sent within a customer service window.
- free_entry_point — indicates the message is free because it is part of a free-entry point conversation.
Message Read
In this case, your webhook endpoint received a messageread event:
- The message
statusisread, which means the message was read by the recipient.
Request
Response
Acknowledge the delivery after durably accepting the event.Explanation
- If the recipient has turned off read receipts, you won’t receive the message
readreceipts.
Message Failed
In this case, your webhook endpoint received a messagefailed event:
- The message
statusisfailed. - Contains
errroCode,errorMessage, andwhatsappApiError.
Request
Response
Acknowledge the delivery after durably accepting the event.Explanation
- These events are intended to notify you of status changes for outbound messages you’ve previously sent to customers.
- The reason for the messaging failure is typically the message request parameters are invalid, the customer’s phone number is not registered, etc. See also WhatsApp Errors for error handling.
whatsappApiErroris provided if we tried to submit this message to Meta’s WhatsApp platform to help you understand the error details. See also Cloud API Error Codes.- We do not charge you for failed messages.

